setTimeout(function() {
	// add context menu options listener
    var contextMenu = document.getElementById("contentAreaContextMenu");
    if (contextMenu) {
      contextMenu.addEventListener("popupshowing", contextItems, false);
	 }
}, 10);

function contextItems()  {  
	var akari2 = document.getElementById("context-akari2");  
	var akari3 = document.getElementById("context-akari3");
	
	akari2.hidden = true;
	akari3.hidden = true;
	
	var ele = document.popupNode;
	
	if (ele.localName.toLowerCase() == 'a') {
		akari2.hidden = false;
	}
	
	if (ele.localName.toLowerCase() == "img") {
		akari3.hidden = false;
	}
} 

function akari() {
	var url = gBrowser.contentWindow.location.href;
	getShort(url);
}

function akari2() {
    var url = gContextMenu.link.href;
	getShort(url);
}

function akari3() {
    var url = gContextMenu.target.getAttribute('src');
	getShort(url);
}

function getShort(u) {
	
	var url = encodeURIComponent(u);
	
	// waaai~ Akari http request dai suki!
	var akariReq = new XMLHttpRequest();
	akariReq.open('GET', 'http://waa.ai/api.php?url='+url, true);
	
	// Once request is finished
	akariReq.onreadystatechange = function () {
        if (akariReq.readyState == 4) {
            if (akariReq.status == 200) {
				var serverResponse = akariReq.responseText;				
				
				// Copy url to clipboard
				// https://developer.mozilla.org/en/Using_the_Clipboard
				var str = Components.classes["@mozilla.org/supports-string;1"].  
				createInstance(Components.interfaces.nsISupportsString);  
				if (!str) return false;  
  
				str.data = serverResponse;  
  
				var trans = Components.classes["@mozilla.org/widget/transferable;1"].  
				createInstance(Components.interfaces.nsITransferable);  
				if (!trans) return false;  
  
				trans.addDataFlavor("text/unicode");  
				trans.setTransferData("text/unicode", str, serverResponse.length * 2);  

				var clipid = Components.interfaces.nsIClipboard;  
				var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid);  
				if (!clip) return false;  
  
				clip.setData(trans, null, clipid.kGlobalClipboard);  
				
				
				var notificationBox = gBrowser.getNotificationBox(); 
				notificationBox.appendNotification(serverResponse + " has been copied to the clipboard", "popup-blocked", "chrome://browser/skin/Info.png", notificationBox.PRIORITY_INFO_LOW);
				setTimeout(function() { notificationBox.removeCurrentNotification(); }, 3500);
            }
        }
    };
   
	// waaai~ Akari request send dai suki!
	akariReq.send();
}
	
